int redled = 15;     // 紅色LED接腳
int greenled = 16;   // 綠色LED接腳
int blueled = 17;    // 藍色LED接腳
int rled = 3;        // 全彩LED紅色接腳  PWM
int gled = 5;        // 全彩LED綠色接腳  PWM
int bled = 6;        // 全彩LED藍色接腳  PWM
int ranum =0;        // 全彩LED紅色亮度參數 0 - 255
int ganum =0;        // 全彩LED綠色亮度參數 0 - 255
int banum=0;         // 全彩LED藍色亮度參數 0 - 255
int rgbbutt=14;      // 轉換"紅綠藍"燈按鈕接腳
int upbutt=7;        // 增加亮度按鈕接腳
int downbutt=8;      // 減少亮度按鈕接腳
int val=0;           // 儲存紅綠藍按鈕狀態
int valup=0;         // 儲存增加亮度按鈕狀態
int valdown=0;       // 儲存減少亮度按鈕狀態
int ledstat=0;       // 儲存 "紅綠藍" 當前參數,全滅=0,  紅色=1 , 綠色=2, 藍色=3

void setup() {
  // put your setup code here, to run once:
Serial.begin(9600);

pinMode (redled, OUTPUT);    // 設定為輸出狀態
pinMode (greenled, OUTPUT);   // 設定為輸出狀態
pinMode (blueled, OUTPUT);   // 設定為輸出狀態
pinMode (rled, OUTPUT);     // 設定為輸出狀態
pinMode (gled, OUTPUT);    // 設定為輸出狀態
pinMode (bled, OUTPUT);    // 設定為輸出狀態
pinMode (rgbbutt, INPUT);  // 設定為輸入狀態
pinMode (upbutt, INPUT);   // 設定為輸入狀態
pinMode (downbutt, INPUT);   // 設定為輸入狀態
}

void loop() {
  // put your main code here, to run repeatedly:
 val = digitalRead(rgbbutt);
 delay(50);
// Serial.println (val);

 if (val == LOW) {
    val = digitalRead(rgbbutt);
    if (val == HIGH){
      ledstat=ledstat+1;  
      
            if (ledstat == 1) {
              digitalWrite(redled,1);
              digitalWrite(greenled,0);
              digitalWrite(blueled,0);
            }
            else if (ledstat == 2) {
              digitalWrite(redled,0);
              digitalWrite(greenled,1);
              digitalWrite(blueled,0);  
            }
            else if (ledstat == 3) {
              digitalWrite(redled,0);
              digitalWrite(greenled,0);
              digitalWrite(blueled,1);  
            }
            else {
              digitalWrite(redled,0);
              digitalWrite(greenled,0);
              digitalWrite(blueled,0);
              ledstat=0;
            }
    }
    
 }

Serial.println (ledstat);
if (ledstat == 1 ) {
        valup = digitalRead(upbutt);
        valdown = digitalRead(downbutt);
        delay(20);
        if (valup == LOW) {
               if (ranum < 255 ){
                 ranum = ranum+1;
                 Serial.println ("紅色"+String(ranum));
               }
        }
        if (valdown == LOW) {
               if (ranum > 0 ){
                 ranum = ranum-1;
               }
        }
analogWrite(rled,ranum);        
}

else if (ledstat == 2) {
        valup = digitalRead(upbutt);
        valdown = digitalRead(downbutt);
        delay(20);
        if (valup == LOW) {
               if (ganum < 255 ){
                 ganum = ganum+1;
               }
        }
        if (valdown == LOW) {
               if (ganum > 0 ){
                 ganum = ganum-1;
               }
        }
analogWrite(gled,ganum);        
}
else if (ledstat == 3) {
        valup = digitalRead(upbutt);
        valdown = digitalRead(downbutt);
        delay(20);
        if (valup == LOW) {
               if (banum < 255 ){
                 banum = banum+1;
               }
        }
        if (valdown == LOW) {
               if (banum > 0 ){
                 banum = banum-1;
               }
        }
analogWrite(bled,banum);        
}

Serial.println (String(ranum)+":"+String(ganum)+":"+String(banum));
}
